"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const linqts_1 = require("linqts");
class Notifiable {
    constructor() {
        this.validations = () => null;
        this.getNotificationsFromValidations = () => this.validations() || new linqts_1.List();
        this._notifications = new linqts_1.List();
    }
    get invalid() {
        return this._notifications.Any() || this.getNotificationsFromValidations().Any();
    }
    get valid() {
        return !this.invalid;
    }
    addNotification(item) {
        this._notifications.Add(item);
    }
    addNotifications(items) {
        this._notifications.AddRange(items.ToArray());
    }
    get notifications() {
        return new linqts_1.List(this._notifications.ToArray()).Concat(this.getNotificationsFromValidations()).ToList();
    }
}
exports.Notifiable = Notifiable;
