"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const notifiable_1 = require("../notifications/notifiable");
const notification_1 = require("../notifications/notification");
class DateValidationContract extends notifiable_1.Notifiable {
    dateIsGreaterThan(val, comparer, property, message) {
        if (val <= comparer) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
    dateIsGreaterOrEqualsThan(val, comparer, property, message) {
        if (val < comparer) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
    dateIsLowerThan(val, comparer, property, message) {
        if (val >= comparer) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
    dateIsLowerOrEqualsThan(val, comparer, property, message) {
        if (val > comparer) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
    dateIsBetween(val, from, to, property, message) {
        if (!(val > from && val < to)) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
}
exports.DateValidationContract = DateValidationContract;
