"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const notifiable_1 = require("../notifications/notifiable");
const notification_1 = require("../notifications/notification");
class NumberValidationContract extends notifiable_1.Notifiable {
    isGreaterThan(val, comparer, property, message) {
        if (val <= comparer) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
    isGreaterOrEqualsThan(val, comparer, property, message) {
        if (val < comparer) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
    isLowerThan(val, comparer, property, message) {
        if (val >= comparer) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
    isLowerOrEqualsThan(val, comparer, property, message) {
        if (val > comparer) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
    numberAreEquals(val, comparer, property, message) {
        if (val !== comparer) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
    numberAreNotEquals(val, comparer, property, message) {
        if (val === comparer) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
    isBetween(val, from, to, property, message) {
        if (!(val > from && val < to)) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
}
exports.NumberValidationContract = NumberValidationContract;
