import { Notifiable } from "../notifications/notifiable";
import { IValidatable } from "./contracts/ivalidatable";
export declare class StringValidationContract extends Notifiable implements IValidatable {
    stringIsNotNullOrEmpty(val: string, property: string, message: string): IValidatable;
    stringIsNullOrEmpty(val: string, property: string, message: string): IValidatable;
    hasMinLen(val: string, min: number, property: string, message: string): IValidatable;
    hasMaxLen(val: string, max: number, property: string, message: string): IValidatable;
    hasLen(val: string, len: number, property: string, message: string): IValidatable;
    stringContains(val: string, text: string, property: string, message: string): IValidatable;
    stringAreEquals(val: string, text: string, property: string, message: string): IValidatable;
    stringAreNotEquals(val: string, text: string, property: string, message: string): IValidatable;
    isEmail(email: string, property: string, message: string): IValidatable;
    isUrl(url: string, property: string, message: string): IValidatable;
    match(value: string, regex: RegExp, property: string, message: string): IValidatable;
}
